/*******************************************************
*
*  jrep.java | A simple grep written in java
*            |
*            | authors:
*            | David Eng (9623205)
*            | Ryan Adams (9631625)
*            |
*            | date:
*            | September 22, 1999
*            |
*            | context:
*            | 308-520A, Assignment 1
*
*******************************************************/

import joos.lib.*;
	
public class jrep {
	
	//
	// Fields
	//
	protected String inputbuffer;	// buffer to keep the input stream
	protected String outputbuffer;	// buffer to keep the output stream
	protected String query;		// user query
	protected int numlines;		// number of lines to process
		
	//
	// Constructor 
	//
	public jrep()
	{
		super();	
		
		inputbuffer = "";	// empty the input buffer
		outputbuffer = "";	// empty the output buffer
		query = null;		// no query
		numlines = 0;		// no lines to process yet
	}
	
	//
	// getInput
	//
	public void getInput()
	{
		String currentline;
		JoosIO joosio;

		currentline = "";
		joosio = new JoosIO();
		
		// Take the query from the first line of the stdin
		query = joosio.readLine();
										
		// While there is still something coming from stdin...
		while( currentline != null )
		{
			// Read a line from standard input			
			currentline = joosio.readLine();
			
			// If something was read..
			if( currentline != null )
			{
				// Save it to the input buffer
				inputbuffer = inputbuffer + currentline + "\n";					
				numlines++;
			}
		}
	}
	
	//
	// getOutput
	//
	public String getOutput()
	{		
		return( outputbuffer );
	}
	
	//
	// printOutput
	//
	public void printOutput()
	{
		JoosIO joosio;
		joosio = new JoosIO();

		if( outputbuffer != null )
		{
			joosio.print( outputbuffer );
		}
	}
	
	//
	// Processba
	//
	public void Process()
	{
		String currentline;
		int currentlinenum;
		int foundlines;
		JoosIO joosio;

		currentlinenum = 0;
		foundlines = 0;		
		
		// if no query was given, return the full input
		if( query == null )
		{
			outputbuffer = inputbuffer;
			return;
		}
		
		while( inputbuffer.length() > 0 )
		{
			// Scan the current line, terminated by \n
			currentline = inputbuffer.substring( 0, inputbuffer.indexOf( "\n", 0 ) + 1 );
			currentlinenum++;
			
			// if we find the query in that line (case-insensitive)...
			if( currentline.toLowerCase().indexOf( query.toLowerCase(), 0 ) != -1 )
			{
				// add that line to the output buffer
				outputbuffer = outputbuffer + "[line " + currentlinenum + "] " + currentline;
				foundlines++;
			}
						
			// remove everything scanned so far from the buffer
			inputbuffer = inputbuffer.substring( inputbuffer.indexOf( "\n", 0 ) + 1, inputbuffer.length() );
		}

		// tag the output
		joosio = new JoosIO();
		joosio.println( "[Generated by jrep - Found '" + query + "' in " + foundlines + "/" + numlines + " lines]" );
		
		return;		
	}
	
	//
	// Main
	//
	public static void main( String args[] )
	{
		jrep j;
		
		j = new jrep();
		
		j.getInput();
		
		j.Process();
		
		j.printOutput();
	}
	
}

// EOF - jrep.java
